var LOGFILE_NAME = "thanos.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};
	var lNerv = {
			logln : function(o) {
			}
		};
	var Utf8 = {
			 
		    // public method for url encoding
		    encode : function (string) {
		        string = string.replace(/\r\n/g,"\n");
		        var utftext = "";
		 
		        for (var n = 0; n < string.length; n++) {
		 
		            var c = string.charCodeAt(n);
		 
		            if (c < 128) {
		                utftext += String.fromCharCode(c);
		            }
		            else if((c > 127) && (c < 2048)) {
		                utftext += String.fromCharCode((c >> 6) | 192);
		                utftext += String.fromCharCode((c & 63) | 128);
		            }
		            else {
		                utftext += String.fromCharCode((c >> 12) | 224);
		                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
		                utftext += String.fromCharCode((c & 63) | 128);
		            }
		 
		        }
		 
		        return utftext;
		    },
		 
		    // public method for url decoding
		    decode : function (utftext) {
		        var string = "";
		        var i = 0;
		        var c = c1 = c2 = 0;
		 
		        while ( i < utftext.length ) {
		 
		            c = utftext.charCodeAt(i);
		 
		            if (c < 128) {
		                string += String.fromCharCode(c);
		                i++;
		            }
		            else if((c > 191) && (c < 224)) {
		                c2 = utftext.charCodeAt(i+1);
		                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
		                i += 2;
		            }
		            else {
		                c2 = utftext.charCodeAt(i+1);
		                c3 = utftext.charCodeAt(i+2);
		                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
		                i += 3;
		            }
		 
		        }
		 
		        return string;
		    }
		 
		};
	
var globalRetryMax = 2;	

lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);
lNerv = new Logger(LOGFILE_NAME);
Property.setSavedProperty=function (path,value) {
	  Property.setProperty(path, value);
	  Property.setFlag(path, 'ARCHIVE', true);
}

function cleanup() {
	if (Property.getNode('queue')!=null) {
		var oArray=Property.getNode('queue').getChildren();
		
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			if (oArray[iIndex].getChild('state')!=null) {
				if (oArray[iIndex].getChild('state').getValue()=='end') {
					lInfo.logln('Removing ' + oArray[iIndex].getName());
					Property.getNode('queue').removeChild(oArray[iIndex].getName());
				}
			}
		}
	}
	
}

function getActiveQueueItem() {
	if (Property.getNode('queue')!=null) {
		var oArray=Property.getNode('queue').getChildren();		
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			if (oArray[iIndex].getChild('state')!=null) {
				if (oArray[iIndex].getChild('state').getValue()=='working') {
					return oArray[iIndex];					
				}
			}
		}
	}
	return null;
}

function startQueue() {
	var fFirst=null;
	if (Property.getNode('queue')!=null) {
		var oArray=Property.getNode('queue').getChildren();
		var fActionPending=false;
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			if (oArray[iIndex].getChild('state')!=null) {
				if (oArray[iIndex].getChild('state').getValue()=='working') {
					lInfo.logln('queue is already in working on ' + oArray[iIndex].getPath());
					return;
				}
				if (oArray[iIndex].getChild('state').getValue()=='queued') {
					if (fFirst==null)
						fFirst=oArray[iIndex].getName();
				}
			}
		}
	}
	if (fFirst!=null) {
		lInfo.logln('starting ' + fFirst);
		Property.setProperty('queue/'+ fFirst + '/state','working');
		new Event ('thanos.queue',{actions:'exec'}).raise();
	} else {
		Property.store();
		lInfo.logln('nothing to do');
		cleanup();
		new Event('thanos.saved',{}).raise();
	}
}

var maxSkips=20;

function exec() {
	maxSkips--;
	var activeItem=getActiveQueueItem();
	var data=activeItem.getChild('data').getChildren();
	var nextItem=null;
	var fDidSomething=false;
	for (var iIndex=0;(iIndex<data.length)&&(nextItem==null) ;iIndex++) {
		if (data[iIndex].getChild('state').getValue()=='pending') {
			nextItem=data[iIndex];
		}
			
	}
	try {
		if (nextItem==null) {
			Property.setProperty(activeItem.getChild('state').getPath(),'end');
			startQueue();
		} else {
			var dsid=nextItem.getChild('dsid').getValue();
			var type=nextItem.getChild('type').getValue();
			var bank=nextItem.getChild('bank').getValue();
			var index=nextItem.getChild('index').getValue();
			var forcedWrite=false;
			if (nextItem.getChild('forced')!=null)
				forcedWrite=nextItem.getChild('forced');
			var sCachePath=nextItem.getChild('cachePath').getValue();
			
			var fShouldFinish=false;
			if (nextItem.getChild('finishEvent')!=null) {
				fShouldFinish=true;
			}
			
			lNerv.logln(type + ' on ' + dsid + ' para ' + bank + '/' + index + ' cache at ' + sCachePath);
			
			
	        if (type=='read') {	        	
		        var value=getDeviceConfig(dsid,bank,index);
		        fDidSomething=true;
				Property.setSavedProperty(sCachePath,value);
				Property.setProperty(nextItem.getChild('state').getPath(),'finish');
			} else if (type=='readNibble') {
		        var value=getDeviceConfig(dsid,bank,index);
		        fDidSomething=true;
		        var sCachePathHighNibble=sCachePath;
		        var sCachePathLowNibble=nextItem.getChild('cachePathLow').getValue();
						        
		    	Property.setSavedProperty(sCachePathLowNibble,value&0x0f);
		    	Property.setSavedProperty(sCachePathHighNibble,((value&0xf0)>>4));
				Property.setProperty(nextItem.getChild('state').getPath(),'finish');
			} else if (type=='readDataBlock') {
				var length=nextItem.getChild('length').getValue();
				var subIndex=0;
				if (nextItem.getChild('subIndex')!=null) {
					subIndex=nextItem.getChild('subIndex').getValue();
				} else {
					Property.setSavedProperty(sCachePath,'');
				}
				
		        var value=getDeviceConfigWord(dsid,bank,index+subIndex);	        
		        
		        var sValue=Property.getProperty(sCachePath);
		        
		        sValue+=String.fromCharCode(value&0xff);
		        sValue+=String.fromCharCode((value>>8)&0xff);	        
		        Property.setSavedProperty(sCachePath,sValue);
		        subIndex+=2;
		        fDidSomething=true;
		        if (subIndex<length) {
		        	Property.setProperty(nextItem.getPath() + '/subIndex',subIndex);
		        	fShouldFinish=false;
		        } else {
		        	Property.setProperty(nextItem.getChild('state').getPath(),'finish');
		        }
		        
			} else if (type=='write') {
				var value=parseInt("" + nextItem.getChild('value').getValue(),10);
				var fShouldWrite=true;
				if (Property.getNode(sCachePath)!=null)
					if (Property.getNode(sCachePath).getValue()==value)
						fShouldWrite=false;
				if (fShouldWrite || forcedWrite) {		
					setDeviceConfig(dsid,bank,index,value)
					fDidSomething=true;
				} else
					lNerv.logln('parameter should not be written!');
				Property.setSavedProperty(sCachePath,value);
				Property.setProperty(nextItem.getChild('state').getPath(),'finish');
			} else if (type=='writeNibble') {
				var valueHigh=parseInt("" + nextItem.getChild('valueHigh').getValue(),10);
				var valueLow=parseInt("" + nextItem.getChild('valueLow').getValue(),10);

		        var sCachePathHighNibble=sCachePath;
		        var sCachePathLowNibble=nextItem.getChild('cachePathLow').getValue();

				var value=((valueHigh<<4)&0xf0)|(valueLow&0x0f);
				lNerv.logln('write now 0x' + value.toString(16));
				var fShouldWrite=true;
				if (Property.getNode(sCachePathHighNibble)!=null)
					if (Property.getNode(sCachePathHighNibble).getValue()==valueHigh)
						if (Property.getNode(sCachePathLowNibble)!=null)
							if (Property.getNode(sCachePathLowNibble).getValue()==valueLow)
								fShouldWrite=false;
				
				if (fShouldWrite || forcedWrite) {					
					setDeviceConfig(dsid,bank,index,value);
					fDidSomething=true;
				} else
					lNerv.logln('parameter should not be written!');
				
				lNerv.logln('save ' + valueLow + ' to ' + sCachePathLowNibble);
				Property.setSavedProperty(sCachePathLowNibble,valueLow);
				lNerv.logln('save ' + valueHigh + ' to ' + sCachePathHighNibble);
		    	Property.setSavedProperty(sCachePathHighNibble,valueHigh);
				Property.setProperty(nextItem.getChild('state').getPath(),'finish');
			} else if (type=='writeTextBlock') {
				var length=nextItem.getChild('length').getValue();
				var subIndex=0;
				if (nextItem.getChild('subIndex')!=null) {
					subIndex=nextItem.getChild('subIndex').getValue();
				} 
				var newString=Utf8.decode(nextItem.getChild('value').getValue()).substring(0,12);
				var oldString=Utf8.decode(Property.getNode(sCachePath).getValue()).substring(0,12);
				
				var bBlockSkip=false;
				if (subIndex==0)
					if (newString==oldString) {
						bBlockSkip=true;
					}
				if ((!bBlockSkip)|| forcedWrite) {
				
					lNerv.logln('set "' + oldString + '" to "' + newString + '" index ' + subIndex);
					
					var newValue=' '.charCodeAt(0);
					if (subIndex<newString.length) {
						newValue=newString.charCodeAt(subIndex);
					} 
										
					var oldValue=0;
					if (subIndex<oldString.length)
						oldValue=oldString.charCodeAt(subIndex);
					
					if ((oldValue!=newValue)||forcedWrite) {		
						lNerv.logln('write ' + newValue);
						setDeviceConfig(dsid,bank,index+subIndex,newValue)
						fDidSomething=true;
					} else
						lNerv.logln('parameter should not be written!');
				
			        while (oldString.length<subIndex)
			        	oldString +=' ';
					oldString=oldString.substr(0,subIndex) + newString.charAt(subIndex) + oldString.substr(subIndex+1);
					lNerv.logln('oldstring ' + oldString);
					Property.setSavedProperty(sCachePath,Utf8.encode(oldString));
					subIndex+=1;
				} else {
					lNerv.logln('String is completly skipped');
					Property.setProperty(nextItem.getPath() + '/subIndex',length-1);
					subIndex=length;
				}
		        if (subIndex<length) {
		        	Property.setProperty(nextItem.getPath() + '/subIndex',subIndex);
		        	fShouldFinish=false;
		        } else {
		        	Property.setProperty(nextItem.getChild('state').getPath(),'finish');
		        }
			}
			if (fShouldFinish) {
				new Event(nextItem.getChild('finishEvent').getValue(),JSON.parse(nextItem.getChild('finishEventParameter').getValue())).raise();
				cleanup();
			}

		}
	}
	catch (e) {
		lWarn.logln('ERROR on Exec :' + e);
		
		if (nextItem.getChild('retry')==null)
			Property.setProperty(nextItem.getPath()+ '/retry',0);
		var retry=nextItem.getChild('retry').getValue();
		if (retry < globalRetryMax) {
			lWarn.logln('Retry ' + retry + ' done, next try sheduled');
			Property.setProperty(nextItem.getPath()+ '/retry',retry+1);
		} else {
			lWarn.logln('finally failed :-(');
			Property.setProperty(nextItem.getChild('state').getPath(),'error');
		}
			
	}
	if (maxSkips==0) {
		lInfo.logln("Exec nothing, but make a short break");
		new Event ('thanos.queue',{actions:'exec'}).raise();
	} else
	if (fDidSomething) {
		lInfo.logln("Exec done something");
		new Event ('thanos.queue',{actions:'exec'}).raise();
	} else {
		lInfo.logln("Exec skipped");
		exec();
	}
}

function enqueueItem() {
	var sID="" + (new Date()).getTime();
    var oParameterObject = JSON.parse(raisedEvent.parameter.values);
    if (oParameterObject.length==0)
		return;
    
	Property.setProperty('queue/' + sID + '/state','queued');
    for (var iIndex=0;iIndex<oParameterObject.length;iIndex++) {
    	for (var sKey in oParameterObject[iIndex]) {
    		try {
    			if ((sKey=='value') && (oParameterObject[iIndex]['type']=='writeTextBlock')) {
	    			Property.setProperty('queue/' + sID + '/data/' + iIndex + '/' + sKey,Utf8.encode(oParameterObject[iIndex][sKey]));
	    		}
	    		else		
	    			Property.setProperty('queue/' + sID + '/data/' + iIndex + '/' + sKey,oParameterObject[iIndex][sKey]);
    		} catch (e) {
    			lWarn.logln('could not write ' + sKey + ' ' + oParameterObject[iIndex][sKey]);
    		}
    	}
    	Property.setProperty('queue/' + sID + '/data/' + iIndex + '/state', 'pending');
    }
    startQueue();
}

if (raisedEvent.parameter.actions=='startQueue') {
	startQueue();
	new Event('thanos.saved',{}).raise();
}

if (raisedEvent.parameter.actions=='exec') {
	exec();
}

if (raisedEvent.parameter.actions=='enqueue') {
	enqueueItem();
	new Event('thanos.saved',{}).raise();
//	startQueue();
}

if (raisedEvent.parameter.actions=='cleanup') {
	cleanup();
	new Event('thanos.saved',{}).raise();
}