Ext.define('DSS.wizard.DeviceRoomSelector', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 270;
	},
	initStores: function ( ){
	    var arrayRooms = [];                                                             
        if (dss.staticDataModel.nameCache != null) {
        	for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        		var oZone = dss.staticDataModel.nameCache[iIndex];
        		if (oZone.ZoneID > 0) {
		             arrayRooms.push({"_id":oZone.ZoneID,
		                              "name":oZone.name});
           }
         } 
       } 
        Ext.data.StoreManager.lookup('wizardSelectorZone').removeAll();
        Ext.data.StoreManager.lookup('wizardSelectorZone').add(arrayRooms);
    },
	constructor : function(config) {
			
		var me=this;
    	                                
        if (Ext.data.StoreManager.lookup('wizardSelectorZone') == null) {
	       Ext.create('Ext.data.Store', {
	            storeId : 'wizardSelectorZone',
	            fields : [ '_id', 'name'],
	            proxy : {
	                type : 'memory',
	                reader : {
	                    type : 'json',
	                    root : 'items'
	                }
	            },
	            sorters: [{property: 'name',direction: 'ASC'}]
	       });
        }
    	this.initStores();
		  this.gridRooms = Ext.create('Ext.grid.Panel', {
		      hideHeaders:true,
		      autoScroll : true,
		      width:200,
		      height:230,
		      margin : '20 40 0 40',
		      viewConfig : {
		          stripeRows : true
		      },
		      selModel : {
		          mode : 'SINGLE',
		      },
		      store : Ext.data.StoreManager.lookup('wizardSelectorZone'),
		      columns : [ {
		          sortable : false,
		          hideable : false,
		          dataIndex : 'name',
		          flex : 1
		      } ]
		  }); 

		this.gridDevices = Ext.create('Ext.grid.Panel', {
			hideHeaders:true,
		    autoScroll : true,
		    width:200,
		    height:230,
		    margin : '20 0 0 40',
		    viewConfig : {
		    	stripeRows : true
		    },
		    selModel : {
		    	mode : 'SINGLE',
		    },
		    store : Ext.data.StoreManager.lookup('baseDSID'),
		    columns : [ {
		    	sortable : false,
		        hideable : false,
		        dataIndex : 'name',
		        flex : 1,
		        renderer: function (value, metaData, record) {
		        	var dsid=record.get('_id');
		        	var oDevice=dss.staticDataModel.getDevice(dsid);
		        	if (record.get('modified'))
		        		return "<table><tr><td>"+oDevice.name+"</td></tr><tr><td>ID: " + oDevice.DisplayID + "</td></tr></table>";
		        	else
		        		return "<table><tr><td><b>"+oDevice.name+"</b></td></tr><tr><td><b>ID: " + oDevice.DisplayID + "</b></td></tr></table>";
		        }
		    } ]
		}); 
                
		this.gridRooms.on('selectionchange',function(view, selections) {
			me.fireEvent('change',{});
		});
		this.gridDevices.on('selectionchange',function(view, selections) {
			me.fireEvent('change',{});
			if (selections.length==1) {
				var dsid=selections[0].get('_id');
				var oDevice=dss.staticDataModel.getDevice(dsid);
				var oRecord=me.gridRooms.store.find('_id',oDevice.ZoneID,0,false,false,true);
				if (oRecord!=null)
					me.gridRooms.getSelectionModel().select(oRecord);
				oDevice.ZoneID
			}
		});
		  
        Ext.apply(this, {
  			items : [ this.gridDevices, this.gridRooms ],
  			height: 270,
  			width:740,
  			layout: {
  				type: 'hbox'
  			}
  		});
  	
  		this.callParent(arguments);
    	
	},
	reset : function() {
		this.initStores();
		if (this.gridRooms.store.getCount()==1) {
			this.gridRooms.getSelectionModel().deselectAll();
			this.gridRooms.getSelectionModel().select(0);
		} else
			this.gridRooms.getSelectionModel().deselectAll();
		if (this.gridDevices.store.getCount()==1) {
			this.gridDevices.getSelectionModel().deselectAll();
			this.gridDevices.getSelectionModel().select(0);
		} else
			this.gridDevices.getSelectionModel().deselectAll();
	},
	isValid : function() {
		return ((this.gridRooms.getSelectionModel().getCount()==1) && (this.gridDevices.getSelectionModel().getCount()==1))		
	},
	setValue : function(oValue,allValues) {
		this.reset();
		if (oValue==null){
			return;
		}
		
		var zoneRecord=this.gridRooms.store.findRecord('_id',oValue.zone,0,false,true,true);
		if (zoneRecord!=null)
			this.gridRooms.getSelectionModel().select(zoneRecord);
		
		var dsidRecord=this.gridDevices.store.findRecord('_id',oValue.baseDSID,0,false,true,true);
		if (dsidRecord!=null)
			this.gridDevices.getSelectionModel().select(dsidRecord);
		

	},
	getValue : function() {
		var dsid=null;
		var zone=null;
		if (this.gridDevices.getSelectionModel().getCount()==1)
			dsid=this.gridDevices.getSelectionModel().getSelection()[0].get('_id');
		if (this.gridRooms.getSelectionModel().getCount()==1)
			zone=this.gridRooms.getSelectionModel().getSelection()[0].get('_id');
		return {baseDSID:dsid,zone:zone};
	}
});