Ext.define('DSS.addon.ScreenTypeSelectorApp', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 391;
	},
	height : '100%',
	initStores : function () {
		if (Ext.data.StoreManager.lookup('screentype-appstore') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-appstore',
				fields : [ '_id', 'button', 'name','action' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});

		} else {
			Ext.data.StoreManager.lookup('screentype-appstore').removeAll();
		}					
	},
	gridStore : null,
	oButtonEdit:null,
	lblSelectorAnzeige:null,
	oButtonUp:null,
	oButtonDown:null,
	oButtonDelete:null,
	mainGrid:null,
	takeOverValue:function() {
	
		this.oButtonEdit.setText(_('edit action'));
		var baseRecord=this.mainGrid.getSelectionModel().getSelection()[0];
		if (baseRecord!=null) { 
			baseRecord.set('action',this.actionEditor.getValue());
			if (baseRecord.get('action')!=null) {
				var aCustom=baseRecord.get('action');
				if (aCustom.length>0) {
					if (aCustom[0].type=='custom-event') {
						var eventNumber=aCustom[0].event;
						var name=dss.staticDataModel.getHLENameFromId(eventNumber);
						baseRecord.set('name',name);
					}
				}
			}
		}
	},
	startEdit:function(iIndex) {
		this.oButtonEdit.setText(_('show all actions'));
    	this.editPanel.expand();    	
    	this.setEditPanel(iIndex);
		var baseRecord=this.mainGrid.getSelectionModel().getSelection()[0];
		if ((baseRecord.get('action')==null) || (baseRecord.get('action')==''))
			this.actionEditor.reset();
		else
			this.actionEditor.setValue(baseRecord.get('action'));
    	this.actionEditor.setHeight(340);
    	this.actionEditor.mainGrid.columns[0].setWidth(610);

	},
	setEditPanel : function (iIndex) {
		this.editPanel.setTitle(_('Apptaster ' + (iIndex+1)));
		var baseRecord=this.mainGrid.getSelectionModel().getSelection()[0];
		if ((baseRecord.get('action')==null) || (baseRecord.get('action')==''))
			this.actionEditor.reset();
		else
			this.actionEditor.setValue(baseRecord.get('action'));
    	this.actionEditor.setHeight(340);
    	this.actionEditor.mainGrid.columns[0].setWidth(610);
	},
	setSelectedMainRecord:function(index) {		
	},
	getSelectedMainRecord:function(index) {
		
	},
	eventHandlerSelectionChange: function () {
		var selections=this.mainGrid.getSelectionModel().getSelection();
		
        if (selections.length > 0) {
        	var oRecord=selections[0];
            this.oButtonEdit.setDisabled(false);
            this.oButtonDelete.setDisabled((oRecord.get('action')==null)||(oRecord.get('action')==''));
            var selIndex = -1;
            for ( var iIndex = 0; iIndex < this.mainGrid.store.getCount(); iIndex++) {
                if (this.mainGrid.store.getAt(iIndex) == selections[0])
                    selIndex = iIndex;
            }
            this.oButtonUp.setDisabled(selIndex == 0);
            this.oButtonDown.setDisabled(selIndex == (this.mainGrid.store.getCount() - 1));
            var iIndex = this.mainGrid.store.indexOf(selections[0]);
            this.lblSelectorAnzeige.setText(Ext.String.format2(_('Apptaster {index}/{count}'),{index:''+(iIndex + 1),count:''+this.mainGrid.store.getCount()}),false);
        } else {
            this.oButtonEdit.setDisabled(true);
            this.oButtonDelete.setDisabled(true);
            this.oButtonUp.setDisabled(true);
            this.oButtonDown.setDisabled(true);
        }
	},
	constructor : function(config) {
		var me=this;
		this.initStores();
		this.gridStore=Ext.data.StoreManager.lookup('screentype-appstore');
        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right'
            }
        });

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('edit action'),
            disabled : true,
            handler : function() {
            	var iIndex = me.mainGrid.store.indexOf(me.mainGrid.getSelectionModel().getSelection()[0]);
            	if (me.editPanel.getCollapsed())
            		me.startEdit(iIndex);
            	else {
            		me.takeOverValue();
                	me.editPanel.collapse();
            	}
            }
        });
        
        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                if (!me.editPanel.getCollapsed()) {
                    me.takeOverValue();
                }
                var iIndex = me.mainGrid.store.indexOf(me.mainGrid.getSelectionModel().getSelection()[0]);
                me.mainGrid.getSelectionModel().setCurrentPosition({row: iIndex-1, column: 0});
        		if (!me.editPanel.getCollapsed())
        			me.setEditPanel(iIndex-1);
            }
        });
        

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                if (!me.editPanel.getCollapsed()) {
                    me.takeOverValue();
                }
                var iIndex = me.mainGrid.store.indexOf(me.mainGrid.getSelectionModel().getSelection()[0]);
                me.mainGrid.getSelectionModel().setCurrentPosition({row: iIndex+1, column: 0});
        		if (!me.editPanel.getCollapsed())
        			me.setEditPanel(iIndex+1);
            }
        });
        
        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('reset button'),
            disabled : true,
            handler : function() {
            	var oRecord=me.mainGrid.getSelectionModel().getSelection()[0];
            	oRecord.set('action',null);
            	me.oButtonDelete.setDisabled(true);
                if (!me.editPanel.getCollapsed()) {
                    var iIndex = me.mainGrid.store.indexOf(oRecord);
                    me.setEditPanel(iIndex+1);
                }
            }
        });
        
        var selModel=Ext.create('Ext.selection.CellModel',
                {allowDeselect:true,
                 mode:'SINGLE'});

        var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {clicksToEdit : 1 });

        this.testRenderer=Ext.create('DSS.component.actionColumn',{});
        
        this.mainGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            selType : 'cellmodel',
            border : '0',
            region : 'center',
            height : "100%",
            store :Ext.data.StoreManager.lookup('screentype-appstore'),
            hideHeaders : true,
            overflowX:'hidden',                
            plugins : [ cellEditing ],
            width:772,
            viewConfig : {
                stripeRows : true
            },
            columns : [ {
                header : _(''),
                dataIndex : '_id',
                sortable : false,
                hideable : false,
                flex:1,
                renderer: function(val, metadata, record, colIdx, store, view) {
                	
                	var actionConf=record.get('action');
                	var buttonID=val;
                	
                	var sString= '<table><tr>';
                		
                	switch (buttonID) {
	            		case 1:
	                    	sString+='<td><img src="images/position/Buttons1.png"></td>';
	                    break;
	            		case 2:
	                    	sString+='<td><img src="images/position/Buttons5.png"></td>';
	                    break;
	            		case 3:
	                    	sString+='<td><img src="images/position/Buttons7.png"></td>';
	                    break;
	            		case 4:
	                    	sString+='<td><img src="images/position/Buttons9.png"></td>';
	                    break;
                	}
                	sString+='<td style="padding-right:5px;width:150px;">';

                	sString+=Ext.String.format2(_('Button {nr}'),{nr:val}) + '</td>';
                	if ((actionConf!=null)&&(actionConf!='')) {
                		sString+='<td>';
                		sString += me.testRenderer.renderer(actionConf,null,null,null,null,null, {up:function() {
                			return {isFieldActive:function(){return true;}};
                		}});
                		sString+='</td>';
                	}
                	sString+='</tr></table>';
                	return sString;                	
                }
            } ,{
                header : _('custom name'),
                dataIndex : 'name',
                sortable : false,
                hideable : false,
                width:120,                
                editor : {
                    xtype : 'textfield',
                    allowBlank : false,
                    blankText : _('This field is required'),
                    invalidText : _('The value in this field is invalid'),
                    maxLength:12,
        			enforceMaxLength:true
                }
            } ],
            tbar : [ this.oButtonEdit,
            // { xtype: 'button', text: 'Erweiterte Ansicht',
            // id: 'action-selector-btn-extended' ,
            // disabled:true},
            '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
        });
        this.mainGrid.getSelectionModel().addListener('select',function(grid,record,row,column) {
           me.eventHandlerSelectionChange(me.mainGrid,[record]);
        });
		
        this.mainGrid.on({
        	itemdblclick : function(grid, record,item,index,e) {     
        		me.startEdit(index);               
	        } 
        });

        this.actionEditor=Ext.create('DSS.component.ActionConfigurator',{
        	 height : 340,
             noHighlevel : false,
             withDelay: true,
             allowNoAction : true,
             enableUsergroup:false,
             userStates:false,
             ignorePresence:false,
             heatingOperationMode:true,
             heatingExtendedOperationMode:false,
             UMRExtendetFunctions:false,
             myID:'elf'
        });
        this.actionEditor.fUseAcutalWidth=true;
		this.editPanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			region : 'south',
            title : ' ',
            collapsible : true,
            collapsed : true,
            autoScroll : true,
            animCollapse : true,
            height : 366,
            width: 740,
            hideCollapseTool:true,
            items: [this.actionEditor],
			layout : {
				type : 'fit'
			},
			listeners : {
				beforecollapse : function(pPanel) {
            		pPanel.setTitle(' ');
            	}
			}
		});

		var me = this;	

		Ext.data.StoreManager.on('clear',function () {
			Ext.data.StoreManager.add('screentype-appstore',me.gridStore);	        
		});
		
		Ext.apply(this, {
			items : [ this.mainGrid,this.editPanel ],
			height: 393,
			width:740,
			layout: {
				type: 'border'
			}
		});
	
		this.callParent(arguments);
	},
	reset : function() {
		Ext.data.StoreManager.lookup('screentype-appstore').removeAll();
	
		Ext.data.StoreManager.lookup('screentype-appstore').add([{
			'_id':1,
			'name' : (_('Button 1')).substr(0,12),
			'actions' : null
		},{
			'_id':2,
			'name' : (_('Button 2')).substr(0,12),
			'actions' : null
		},{
			'_id':3,
			'name' : (_('Button 3')).substr(0,12),
			'actions' : null
		},{
			'_id':4,
			'name' : (_('Button 4')).substr(0,12),
			'actions' : null
		}]);

        
        me.editPanel.collapse();

	},
	isValid : function() {
		return true;
	},
	setValue : function(oValue) {

        this.editPanel.collapse();
        
		Ext.data.StoreManager.lookup('screentype-appstore').removeAll();
		
		for (var iIndex=1;iIndex<5;iIndex++) {
			var oObject={
				'_id':iIndex, 
				'name':(oValue['button' + iIndex].name.trimRight()).substr(0,12),
				'action':oValue['button' + iIndex].actions
			};
			Ext.data.StoreManager.lookup('screentype-appstore').add(oObject);
		}
	},
	getValue : function() {
		if (!this.editPanel.getCollapsed())
			this.takeOverValue();
		var oObject={};
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('screentype-appstore').getCount();iIndex++) {
			var oRecord=Ext.data.StoreManager.lookup('screentype-appstore').getAt(iIndex);
			var subObject={}
			subObject.name=oRecord.get('name');
			subObject.actions=oRecord.get('action');
			oObject['button' + oRecord.get('_id')]=subObject;
		}
		return oObject;
	}
});